
#define HISTORY_SIZE 15

global
  int hst_position[HISTORY_SIZE];
  int hst_head=0, hst_tail=0; hst_curr=0;
end

function hst_reset()
begin
  hst_head = hst_tail = hst_curr = 0;
end

function hst_remember_pos( int pos )
begin
  if( hst_get() == pos ) return; end
  hst_position[ hst_head ] = pos;
  hst_head++;
  if( hst_head == hst_tail ) hst_tail++; end
  if( hst_tail >= HISTORY_SIZE ) hst_tail = 0; end
  if( hst_head >= HISTORY_SIZE ) hst_head = 0; hst_tail = 1; end
  hst_curr = hst_head -1;
  if( hst_curr < 0 ) hst_curr = HISTORY_SIZE -1; end
//  say('SVD '+hst_curr+' ('+hst_tail+':'+hst_head+')');
end

function hst_mov_next()
begin
  hst_curr++;
//  say('++ '+hst_curr);
  if( hst_curr >= HISTORY_SIZE ) hst_curr = 0; end
  if( hst_tail < hst_head )
    if( hst_curr >=  hst_head-1 ) hst_curr = hst_head-1; end
  else
    if( hst_curr >=  hst_head-1 && hst_curr < hst_tail ) hst_curr = hst_head-1; end
  end
  if( hst_curr < 0 ) hst_curr = HISTORY_SIZE -1; end
end

function hst_mov_prev()
begin
  hst_curr--;
//  say('-- '+hst_curr+' * '+hst_tail);
  if( hst_curr <  0 ) hst_curr = HISTORY_SIZE-1; end
  if( hst_tail< hst_head )
    if( hst_curr < hst_tail ) hst_curr = hst_tail; end
  else
    if( hst_curr < hst_tail && hst_curr >= hst_head ) hst_curr = hst_tail; end
  end
  if( hst_curr < 0 ) hst_curr = HISTORY_SIZE -1; end
end

function int hst_get()
begin
//  say('LDD '+hst_curr+' ('+hst_tail+':'+hst_head+')');  
  if( hst_head == hst_tail ) return -1; end;
  return hst_position[ hst_curr ];
end

