import "mod_file"
       
#include "../lib/text.inc.prg"
#include "lists_fmt.inc.prg"
       
#include "history.inc.prg"       

       
       
declare process reader2 ( stringlist *menu, int maxlines, int cwidth  )
local
  int i,j,n,t;
  int mw, mh, tw, th ,nowml;	
  int toppos, redraw;
  int shift;
end
end

/*--------------------------------------------------------------------------*/

process reader_roller( int ctld )
local
  reader2 dx;
end
begin
  dx = ctld;
  while ( exists(dx) )
    dx.shift--;
    if( dx.shift < -dx.mh )
      dx.toppos++;
      hst_remember_pos( dx.toppos );
      dx.shift += dx.mh;
    end
    dx.redraw = 1;
    frame 150;
  end
end
/*--------------------------------------------------------------------------*/

process load_progress(int *progress, string title)
local
  wm_window wnd;
  menu_progressbar box;
  int stage;
end
begin
  box = menu_progressbar( 0, 100, progress );
  wnd = wm_window( box, WM_W_UNREGISTRED );
  wnd.title = title;
  
  frame;
  wnd.x = 160  - wnd.ww / 2;
  wnd.y = 120 - wnd.wh / 2;
  //wnd.z = -1;
  frame;
  stage = 0;
  while( exists(wnd) && stage == 0 )    
    frame;
  end;
  
  while( exists(wnd) && stage == 1 )
    frame;
  end;
  
onexit
  signal( wnd, S_KILL );
end

/*--------------------------------------------------------------------------*/
process reader( string filename )
local
  stringlist lst;
  int rows, cols, kthr;
  menu_textbox box;
  reader2 dx;
  int fd, i, j;
  load_progress p;
  int savproc;
end
begin
  wm_cursor_off();
  
  say( "Reader" );
  say( "Loading: "+filename );
  
  rows = 230 / txt_render_opt_cfnt_font.height;
  cols = 310 / txt_render_opt_cfnt_font.width;
  
  if( fexists( filename+".8fmt" ) )
    say('Preformatted');
    lst_load_8fmt( &lst, filename+".8fmt" );
    //list_create_fn( &lst, filename+".8fmt" );
  else
    list_create_fn( &lst, filename );
    i = 0;
    p = load_progress(&i, "Formatting");
    word_wrap_8bit( &lst, cols, &i );
    p.stage = 1;
    savproc = lst_save_8fmt( &lst, filename+".8fmt" );
    signal( p, S_KILL );
  end
  
  if( fexists( filename+".8bst") )
    i = 0;
    fd = fopen( filename+".8bst", O_READ );
    if( fd )
      i = atoi( fgets(fd) );
      fclose( fd );
    end
    say('Has state: '+i);
  else
    i = 0;
  end
  
  map_clear( 0, 0, wm_c_bg );
  
  dx = reader2( &lst , rows+1, cols);
  dx.z = wm_z_inact + 100;
  
  hst_reset();
  hst_remember_pos( i );
  dx.toppos = i;
  dx.redraw = 1;
  
  dx.x = 6;
  dx.y = 6;
    
  loop
    
    //input_allow(id);
    
    if( jkey( _JKEY_B ) )
      kthr = 10;
      while( kthr-- && jkey( _JKEY_B ) ) frame; end
      if( exists( type reader_roller ) )
	signal( type reader_roller, S_KILL );
      else
	reader_roller(dx);
      end
    end
    
    if( jkey( WM_KEY_UP ) )
      kthr = 4;
      while( kthr-- && jkey( WM_KEY_UP ) ) frame; end
      if( jkey( _JKEY_SELECT ) )
	dx.toppos -= rows;
	hst_remember_pos( dx.toppos );
	dx.redraw = 1;
      else
	dx.toppos --;
	hst_remember_pos( dx.toppos );
	dx.redraw = 1;    
      end
    end
    
    if( jkey( WM_KEY_DOWN )  )
      kthr = 4;
      while( kthr-- && jkey( WM_KEY_DOWN ) ) frame; end
      if( jkey( _JKEY_SELECT ) )
	dx.toppos += rows;
	hst_remember_pos( dx.toppos );
	dx.redraw = 1;
      else
	dx.toppos ++;
	hst_remember_pos( dx.toppos );
	dx.redraw = 1;
      end
    end
    
    if( jkey( _JKEY_Y ) )
      kthr = 4;
      while( kthr-- && jkey( _JKEY_Y ) ) frame; end
      dx.toppos = 0;
      hst_remember_pos( dx.toppos );
      dx.redraw = 1;
    end
    
    if( jkey( _JKEY_X )  )
      kthr = 4;
      while( kthr-- && jkey( _JKEY_X ) ) frame; end
      dx.toppos = lst.count;
      hst_remember_pos( dx.toppos );
      dx.redraw = 1;
    end
    
    if( jkey( _JKEY_L ) )
      if( jkey( _JKEY_SELECT) ) 
	
	list_create_fn( &lst, filename );
	i = 0;
	p = load_progress(&i, "Formatting");
	word_wrap_8bit( &lst, cols, &i );
	p.stage = 1;
	savproc = lst_save_8fmt( &lst, filename+".8fmt" );
	signal( p, S_KILL );	
	
      else
      
	kthr = 4;
	while( kthr-- && jkey( _JKEY_L ) ) frame; end
	dx.toppos -= rows;
	hst_remember_pos( dx.toppos );
	dx.redraw = 1;
      
      end
    end
    
    if( jkey( _JKEY_R ) )
      kthr = 4;
      while( kthr-- && jkey( _JKEY_R )  ) frame; end
      dx.toppos += rows;
      hst_remember_pos( dx.toppos );
      dx.redraw = 1;
    end
    
    if( jkey( _JKEY_VOLDOWN ) ||  jkey( _JKEY_A ) )
      kthr = 4;
      while( kthr-- && ( jkey( _JKEY_VOLDOWN ) ||  jkey( _JKEY_A ) ) ) frame; end
      hst_mov_prev();
      dx.toppos = hst_get();
      dx.redraw = 1;
    end
    
    if( jkey( _JKEY_VOLUP ) )
      kthr = 4;
      while( kthr-- && jkey( _JKEY_VOLUP ) ) frame; end
      hst_mov_next();
      dx.toppos = hst_get();
      dx.redraw = 1;
    end
    
    if( jkey( _JKEY_MENU ) )
      while( jkey( _JKEY_MENU ) ) frame; end
      return;
    end
    
    frame;
  end;
onexit
  fd = fopen( filename+".8bst", O_WRITE );
  if( fd )
    fputs( fd, itoa(dx.toppos) );
    say("saved: " + dx.toppos );
    fclose( fd );
  end
  signal( dx, S_KILL );
  list_free( &lst );
end

/*--------------------------------------------------------------------------*/

process reader2 ( stringlist *menu, int maxlines,int cwidth  )
begin
  
  graph = 0;
  
  if(!menu.ready) return; end;
  
  //effective list height in lines
  nowml = ( menu.count < maxlines ) ? menu.count : maxlines ;
  
  mw = 0;
  mh = 0;
  j  = 0;
  shift = 0;
  
  i=0;
  t = text_to_map( lpad("",cwidth) );
  tw = graphic_info( file, t, G_WIDTH);
  th = graphic_info( file, t, G_HEIGHT);
  map_unload( file, t );
  mw = tw>mw ? tw : mw;
  mh = th>mh ? th : mh;
    
  graph = map_new( mw + 2, mh*nowml + 2, 16 );
  set_center( file, graph, 0, 0);
  map_clear( file, graph, wm_c_bg );
  
  redraw = 1;
  loop
    
    if( toppos < 0 ) toppos = 0; end
    if( toppos > menu.count - maxlines ) toppos = menu.count - maxlines; end
      
    if( redraw )
      map_clear( file, graph, wm_c_bg );
      th = 0;
      set_text_color( wm_c_fg );
      for( i=toppos, j=0 ; j < nowml && i < menu.count; i++, j++ )
	
	t = text_to_map( list_item( menu, i ) );
	map_put( file, graph, t, 1, th+1 + shift );
	th += graphic_info( file, t, G_HEIGHT );
	map_unload( file, t );
      
      /*
	text_on_map( list_item( menu, i ), graph, 1, th+1 );
	th += txt_render_opt_cfnt_font.height;
	*/
      end;
      redraw = 0;
      //x = 1; // update flag
    end
    
    frame;
  end;
  
onexit
  if( graph )
    map_unload( file, graph );
  end;
end;

